﻿#pragma once
#if defined(_WIN32) || defined(__ORBIS__)
#ifdef _GMESDK_IMPLEMENT_
#define AV_EXPORT __declspec(dllexport)
#else
#define AV_EXPORT __declspec(dllimport)
#endif
#define QAVSDK_API extern "C" AV_EXPORT
#define QAVSDK_CALL __cdecl
#define __UNUSED
#else
#define QAVSDK_API extern "C"  __attribute__ ((visibility("default")))
#define QAVSDK_CALL
#define __UNUSED __attribute__((unused))
#endif

typedef enum {
    ITMG_PERMISSION_GRANTED = 0 ,//麦克风已授权
    ITMG_PERMISSION_Denied = 1,//麦克风被禁用
    ITMG_PERMISSION_NotDetermined = 2 ,//尚未弹出权限框向用户申请权限
    ITMG_PERMISSION_ERROR = 3,//接口调用错误
}ITMG_RECORD_PERMISSION;

typedef enum {
	ITMG_ROOM_TYPE_FLUENCY = 1,
	ITMG_ROOM_TYPE_STANDARD = 2,
	ITMG_ROOM_TYPE_HIGHQUALITY = 3,
}ITMG_ROOM_TYPE;

typedef enum {
	ITMG_ROOM_CHANGE_EVENT_ENTERROOM = 1,
	ITMG_ROOM_CHANGE_EVENT_START = 2,
	ITMG_ROOM_CHANGE_EVENT_COMPLETE = 3,
	ITMG_ROOM_CHANGE_EVENT_REQUEST = 4
}ITMG_ROOM_TYPE_SUB_EVENT;

typedef ITMG_ROOM_TYPE_SUB_EVENT ITMG_ROOM_CHANGE_EVENT;/*ITMG_ROOM_CHANGE_EVENT is deprecated*/
/*
 *	//TMG event enumeration that from a callback event
 */
typedef enum {
	ITMG_MAIN_EVENT_TYPE_NONE = 0,

	//Notification of entering a room, triggered by EnterRoom API.
	ITMG_MAIN_EVENT_TYPE_ENTER_ROOM = 1,
	//Notification of exiting a room, triggered by ExitRoom API.
	ITMG_MAIN_EVENT_TYPE_EXIT_ROOM = 2,
	//Notification of room disconnection due to network or other reasons, which will trigger automatically.
	ITMG_MAIN_EVENT_TYPE_ROOM_DISCONNECT = 3,
	//Notification of the updates of room members, the notification contains detailed information, refer to ITMG_EVENT_ID_USER_UPDATE.
	ITMG_MAIN_EVNET_TYPE_USER_UPDATE = 4,

	ITMG_MAIN_EVENT_TYPE_NUMBER_OF_USERS_UPDATE=7,// number of users in current room
	ITMG_MAIN_EVENT_TYPE_NUMBER_OF_AUDIOSTREAMS_UPDATE = 8,// number of audioStreams in current room
	//Notification of room reconnection happened, which indicates services will be temporarily unavailable.
	ITMG_MAIN_EVENT_TYPE_RECONNECT_START = 11,
	//Notification of room reconnection succeeded, which indicates services have recovered.
	ITMG_MAIN_EVENT_TYPE_RECONNECT_SUCCESS = 12,
	//Notification of RoomType have been Changed by Other EndUser
	ITMG_MAIN_EVENT_TYPE_CHANGE_ROOM_TYPE = 21,

	ITMG_MAIN_EVENT_TYPE_AUDIO_DATA_EMPTY = 22,

	ITMG_MAIN_EVENT_TYPE_RECORD_COMPLETED = 30,
	ITMG_MAIN_EVENT_TYPE_RECORD_PREVIEW_COMPLETED = 31,
	ITMG_MAIN_EVENT_TYPE_RECORD_MIX_COMPLETED = 32,

	//Notify user the default speaker device is changed in the PC, refresh the Speaker devices when you recv this event.
	ITMG_MAIN_EVENT_TYPE_SPEAKER_DEFAULT_DEVICE_CHANGED = 1008,
	//Notify user new Speaker device in the PC, refresh the Speaker devices when you recv this event.
	ITMG_MAIN_EVENT_TYPE_SPEAKER_NEW_DEVICE = 1009,
	//Notify user speaker device lost from the PC, refresh the Speaker devices when you recv this event.
	ITMG_MAIN_EVENT_TYPE_SPEAKER_LOST_DEVICE = 1010,
	//Notify user new mic device in the PC, refresh the Speaker devices when you recv this event.
	ITMG_MAIN_EVENT_TYPE_MIC_NEW_DEVICE = 1011,
	//Notify user mic device lost from the PC, refresh the Speaker devices when you recv this event.
	ITMG_MAIN_EVENT_TYPE_MIC_LOST_DEVICE = 1012,
	//Notify user the default mic device is changed in the PC, refresh the mic devices when you recv this event.
	ITMG_MAIN_EVENT_TYPE_MIC_DEFAULT_DEVICE_CHANGED = 1013,

	ITMG_MAIN_EVENT_TYPE_AUDIO_ROUTE_CHANGED = 1014,

	//Notification of volumes of users in room
	ITMG_MAIN_EVENT_TYPE_USER_VOLUMES = 1020,
	
	//quality information
	ITMG_MAIN_EVENT_TYPE_CHANGE_ROOM_QUALITY = 1022,  

	//Notification of accompany finished
	ITMG_MAIN_EVENT_TYPE_ACCOMPANY_FINISH = 1090,
	
    ITMG_MAIN_EVNET_TYPE_AUDIO_READY = 2000,
	
	// Notification of PTT Record
	ITMG_MAIN_EVNET_TYPE_PTT_RECORD_COMPLETE = 5001,
	// Notification of PTT Upload
    ITMG_MAIN_EVNET_TYPE_PTT_UPLOAD_COMPLETE = 5002,
	// Notification of PTT Download
    ITMG_MAIN_EVNET_TYPE_PTT_DOWNLOAD_COMPLETE = 5003,
	// Notification of PTT Play
    ITMG_MAIN_EVNET_TYPE_PTT_PLAY_COMPLETE = 5004,
	// Notification of PTT 2Text
    ITMG_MAIN_EVNET_TYPE_PTT_SPEECH2TEXT_COMPLETE = 5005,
    // Notification of StreamRecognition
    ITMG_MAIN_EVNET_TYPE_PTT_STREAMINGRECOGNITION_COMPLETE = 5006,

} ITMG_MAIN_EVENT_TYPE;

/*
 *	对应，ITMG_MAIN_EVENT_TYPE::ITMG_MAIN_EVNET_TYPE_USER_UPDATE//correspond,ITMG_MAIN_EVENT_TYPE::ITMG_MAIN_EVNET_TYPE_USER_UPDATE
 *  详情枚举//Details enumeration
 */
typedef enum {
	//Notification of entering a room
	ITMG_EVENT_ID_USER_ENTER=1,
	//Notification of exiting a room
	ITMG_EVENT_ID_USER_EXIT=2,
	//Notification of member up video
	ITMG_EVENT_ID_USER_HAS_CAMERA_VIDEO=3,
	//Notification of member not up video any more
	ITMG_EVENT_ID_USER_NO_CAMERA_VIDEO=4,

	//Notification of member audio event
	ITMG_EVENT_ID_USER_HAS_AUDIO=5,
	//Notification of no member audio event is received for 2 seconds
	ITMG_EVENT_ID_USER_NO_AUDIO=6,
} ITMG_EVENT_ID_USER_UPDATE;
typedef ITMG_EVENT_ID_USER_UPDATE ITMG_EVENT_ID_USER;/*ITMG_EVENT_ID_USER is deprecated*/

typedef	enum {
	//Do not print the log
	TMG_LOG_LEVEL_NONE	  = 0, /*deprecated */
	ITMG_LOG_LEVEL_NONE	  = 0, 
	//Used for critical log
	TMG_LOG_LEVEL_ERROR   = 1,/*deprecated */
	ITMG_LOG_LEVEL_ERROR   = 1,
	//Used to prompt for information
	TMG_LOG_LEVEL_INFO    = 2,/*deprecated */ 
	ITMG_LOG_LEVEL_INFO    = 2,
	//For development and debugging
	TMG_LOG_LEVEL_DEBUG   = 3,/*deprecated */
	ITMG_LOG_LEVEL_DEBUG   = 3,
	//For high-frequency printing information
	TMG_LOG_LEVEL_VERBOSE = 4,/*deprecated */
	ITMG_LOG_LEVEL_VERBOSE = 4,
} ITMG_LOG_LEVEL;

#define DEVICEID_DEFAULT "0"
/*
 *voice change types,
 */
typedef enum {
    ITMG_VOICE_TYPE_ORIGINAL_SOUND = 0,
    ITMG_VOICE_TYPE_LOLITA = 1,
    ITMG_VOICE_TYPE_UNCLE = 2,
	ITMG_VOICE_TYPE_INTANGIBLE = 3,
	ITMG_VOICE_TYPE_DEAD_FATBOY = 4,
    ITMG_VOICE_TYPE_HEAVY_MENTAL = 5,
	ITMG_VOICE_TYPE_DIALECT = 6,
	ITMG_VOICE_TYPE_INFLUENZA = 7,
	ITMG_VOICE_TYPE_CAGED_ANIMAL = 8,
    ITMG_VOICE_TYPE_HEAVY_MACHINE = 9,
    ITMG_VOICE_TYPE_STRONG_CURRENT = 10,
	ITMG_VOICE_TYPE_KINDER_GARTEN = 11,
	ITMG_VOICE_TYPE_HUANG = 12,
	ITMG_VOICE_TYPE_COUNT,
} ITMG_VOICE_TYPE;

typedef enum {
	ITMG_KARAOKE_TYPE_ORIGINAL = 0,
	ITMG_KARAOKE_TYPE_POP = 1,
	ITMG_KARAOKE_TYPE_ROCK = 2,
	ITMG_KARAOKE_TYPE_RB = 3,
	ITMG_KARAOKE_TYPE_DANCE = 4,
	ITMG_KARAOKE_TYPE_HEAVEN = 5,
	ITMG_KARAOKE_TYPE_TTS = 6,
	ITMG_KARAOKE_TYPE_VIGOROUS = 7,
	ITMG_KARAOKE_TYPE_LIMPID = 8,
	ITMG_KARAOKE_TYPE_COUNT,
} ITMG_KARAOKE_TYPE;

typedef enum
{
	ITMG_RANGE_AUDIO_MODE_WORLD = 0x0,
	ITMG_RANGE_AUDIO_MODE_TEAM = 0x1,
} ITMG_RANGE_AUDIO_MODE;

typedef struct _tag_ITMG_VOICE_TYPE_EQUALIZER
{
	float EQUALIZER_32HZ;
	float EQUALIZER_64HZ;
	float EQUALIZER_128HZ;
	float EQUALIZER_250HZ;
	float EQUALIZER_500HZ;
	float EQUALIZER_1KHZ;
	float EQUALIZER_2KHZ;
	float EQUALIZER_4KHZ;
	float EQUALIZER_8KHZ;
	float EQUALIZER_16KHZ;
	float EQUALIZER_MASTER_GAIN;
}ITMG_VOICE_TYPE_EQUALIZER;

typedef struct _tag_ITMG_VOICE_TYPE_REVERB
{
	float HARMONIC_GAIN;					//[0,1]
	float HARMONIC_START_FREQUENCY;			//[0,1]
	float HARMONIC_BASS_CONTROL;			//[0,1]
	float REVERB_SIZE;						//[0,1]
	float REVERB_DEPTH;						//[0,1]
	float REVERB_GAIN;						//[0,1]
	float REVERB_ECHO_DEPTH;				//[0,1]
}ITMG_VOICE_TYPE_REVERB;

typedef enum
{
	AUDIO_ROUTE_TYPE_OTHERS = -1,			//其他设备
	AUDIO_ROUTE_TYPE_BUILDINRECIEVER = 0,	//听筒设备
	AUDIO_ROUTE_TYPE_SPEAKER = 1,			//扬声器
	AUDIO_ROUTE_TYPE_HEADPHONE = 2,			//耳机
	AUDIO_ROUTE_TYPE_BLUETOOTH = 3,			//蓝牙
} ITMG_AUDIO_ROUTE_TYPE;

static const char* GMESDK_VERSION_f4e1d4ecd6d38f290ed79b84b415da805a1d77e0 __UNUSED = "f4e1d4ecd6d38f290ed79b84b415da805a1d77e0";

